import { model, Schema, Document } from "mongoose"
import { authProviders } from '../types'

export interface User extends Document {
  providerId: string
  name: string
  email: string
  provider: authProviders
  photo?: string
}

const userSchema = new Schema(
  {
    providerId: {
      type: String,
      required: true
    },
    provider: {
      type: String,
      required: true,
    },
    name: {
      type: String,
      required: true,
    },
    email: {
      type: String,
      required: true,
    },
    photo: String
  },
  { timestamps: true }
)

const UserModel = model<User>("User", userSchema)
export default UserModel
